QGIS Application - Bug report #1933
Fix PostGIS dataprovider to check for unique data with SQL where clause
2009-09-16 05:21 PM - Jeremy Palmer

Status: Closed

Priority: Low

Assignee: Jurgen Fischer

Category: Data Provider

Affected QGIS version: Regression?: No
Operating System: All Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 11993
Description

The method [[QgsPostgresProvider]]::uniqueData within ggspostgresprovider.cpp should be updated to use the SQL where cause for
determining if the set primary key provides unique data.

if ( !sqlWhereClause.isEmpty() )
{

sql +="where " + sqlWhereClause;

}

Associated revisions

Revision b6c3bc09 - 2009-09-23 01:26 AM - Jiirgen Fischer
postgres provider update:
- only use typlen for char fields

- use subset string when checking for key uniqueness and recheck in setSubsetString() (fixes #1933)

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@11703 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

Revision b9508088 - 2009-09-23 01:26 AM - Jiirgen Fischer
postgres provider update:
- only use typlen for char fields

- use subset string when checking for key uniqueness and recheck in setSubsetString() (fixes #1933)

git-svn-id: http://svn.osgeo.org/qgis/trunk@11703 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2009-09-22 10:33 AM - Jiirgen Fischer
- Resolution set to wonitfix

- Status changed from Open to Closed

the where clause can be changed later, to the id needs to be unique even without the where clause. An alternative would be to create a view with the
desired clause.
#2 - 2009-09-22 10:33 AM - Jiirgen Fischer

s/to/so/

#3 - 2009-09-22 03:03 PM - Jeremy Palmer

- Status changed from Closed to Feedback
- Resolution deleted (wontfix)

The case | was wanting to implement already involves a view. It would be useful to use the where cause to show different spatial datasets based on this

view.

How about modifying the [[QgsPostgresProvider]]::setSubsetString method to recheck for the unique primary key by calling the
[[QgsPostgresProvider]]::uniqueData() method?

I would be really great to have this feature so | can build a python plug-in to dynamically add and view multiple vector layers based on a dataset identifier.

#4 - 2009-09-22 04:27 PM - Jiirgen Fischer

- Resolution set to fixed

- Status changed from Feedback to Closed

Replying to [comment:3 jpalmer]:
How about modifying the [[QgsPostgresProvider]]::setSubsetString method to recheck for the unique primary key by calling the
[[QgsPostgresProvider]]::uniqueData() method?

good point. Thanks.

Fixed in commit:b9508088 (SVN r11704)
